﻿using System;
using System.Linq;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;

namespace RFID_Demo
{
    public partial class frmPassword : Form
    {
        frmMain fc;
        public frmPassword(frmMain fc)
        {
            InitializeComponent();
            this.fc = fc;
        }

        private void CloseItem_Click(object sender, EventArgs e)
        {
            if (MessageBox.Show("Close Form ?", this.Text, MessageBoxButtons.YesNo, MessageBoxIcon.Question, MessageBoxDefaultButton.Button1) == DialogResult.Yes)
            {
                Close();
            }
        }
        private void ChangePasswordHitag2()
        {
            string Res = string.Empty;
            Res = fc.MyBTLF.ChangeHitag2Password(txtPassword1.Text, txtPassword2.Text);
            if (Res.IndexOf("+") >= 0)
            {
                MessageBox.Show("OK");
                fc.MyBTLF.Hitag2Password = txtPassword2.Text;
                txtPassword1.Text = txtPassword2.Text;
            }
            else if (Res.IndexOf("- 4") >= 0)
            {
                MessageBox.Show("No Transponder selected");
            }
            else
            {
                MessageBox.Show("[" + Res + "]Error");
            }
        }

        private void ChangePasswordTitan()
        {
            string Res = string.Empty;
            Res = fc.MyBTLF.ChangeTitanPassword(txtPassword1.Text, txtPassword2.Text);
            if (Res.IndexOf("+") >= 0)  // ERROR: Unknown binary operator Like
            {
                MessageBox.Show("OK");
                fc.MyBTLF.TitanPassword = txtPassword2.Text;
                txtPassword1.Text = txtPassword2.Text;
            }
            else if (Res.IndexOf("- 4") >= 0) // ERROR: Unknown binary operator Like
            {
                MessageBox.Show("No Transponder selected");
            }
            else
            {
                MessageBox.Show("[" + Res + "]Error");
            }
        }

        private void btChange_Click(object sender, EventArgs e)
        {
            //0 - EM 41xx (UNIQUE) - RO
            //1 - HITAG S - RW
            //2 - FDX-B ISO 11784/5-RO
            //3 - Q5 / 5557 -- RW
            //4 - HDX Transponder (TI)-RW
            //5 - HITAG 2 - RW
            //6 - EM 4305 - RW
            //7 - EM4450/4550 (TITAN)-RW
            if (MessageBox.Show("Do you want to change the password ?", this.Text, MessageBoxButtons.YesNo, MessageBoxIcon.Question, MessageBoxDefaultButton.Button1) == DialogResult.Yes)
            {
                if (fc.TagType == 7)
                {
                    ChangePasswordTitan();
                }
                if (fc.TagType == 5)
                {
                    ChangePasswordHitag2();
                }
            }
        }


    }
}