﻿using System;
using System.Linq;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;
// 15.11.2012...only USB is work...
// 22.01.2013...repeat..read write UID...

namespace RFID_Demo
{
    public partial class frmUHF : Form
    {
        frmMain fc;
        public frmUHF(frmMain fc)
        {
            InitializeComponent();
            this.fc = fc;
        }
        public bool IsKeyAction;

        private bool IsRefreshRFID;

        public void InfoAdd(string Value)
        {
            try
            {
                if ((string.IsNullOrEmpty(Value)))
                {
                    return;
                }
                //Dim itmp As New Windows.Forms.ListViewItem(Value)
                ListBox1.Items.Add(Value);
                ListBox1.SelectedIndex = ListBox1.Items.Count - 1;
                if (ListBox1.Items.Count >= 1000)
                {
                    ListBox1.Items.Clear();
                }
            }
            catch (Exception ex)
            {
                //            WriteErrorFile(ex.Message)
            }

        }

        public bool ReadTransponder()
        {
            bool Result = false;
            IsKeyAction = true;
            btReadTransponder_Click(null, null);
            IsKeyAction = false;
            Result = true;
            return Result;
        }


        private void btReadTransponder_Click(object sender, EventArgs e)
        {
            try
            {
                btReadTransponder.Enabled = false;
                btReadWriteData.Enabled = false;
                btGetVersion.Enabled = false;
                if (cbConti.Checked)
                {
                    InfoAdd("Start Continues Read");
                }
                do
                {
                    System.Windows.Forms.Application.DoEvents();
                    if (lbReaderInfo.Text == "No Reader")
                    {
                        if (fc.RFID_UHF.GetReaderInfo(0))
                        {
                            lbReaderInfo.Text = fc.RFID_UHF.InfoReader[2].ToString();
                        }
                        else
                        {
                            lbReaderInfo.Text = "No Reader";
                        }
                    }
                    InfoAdd("Search...UID");
                    if (fc.RFID_UHF.GetUID_Repeat())
                    {
                        InfoAdd("TAG-Nr. :" + fc.RFID_UHF.UIDNr);
                        InfoAdd(fc.RFID_UHF.TagTyp);
                        fc.PlaySound();
                        fc.SendUIDNr(fc.RFID_UHF.UIDNr);
                    }
                    else
                    {
                        InfoAdd("No UID found");
                        InfoAdd(fc.errortext);
                        if ((fc.RFID_UHF.LastErrorID == -1039) | (fc.RFID_UHF.LastErrorID == -1030))
                        {
                            IsRefreshRFID = true;
                            InfoAdd("Reader = Reader Error");
                        }
                        else
                        {
                            IsRefreshRFID = false;
                        }
                        if (IsRefreshRFID)
                        {
                            ListBox1.Items.Add("InitReaderUHF_USB");
                            fc.InitReaderUHF_USB();
                        }
                    }
                } while (cbConti.Checked);
            }
            finally
            {
                btReadTransponder.Enabled = true;
                btReadWriteData.Enabled = true;
                btGetVersion.Enabled = true;
            }
        }

        private void btGetVersion_Click(object sender, EventArgs e)
        {
            try
            {
                btReadTransponder.Enabled = false;
                btReadWriteData.Enabled = false;
                btGetVersion.Enabled = false;
                if (fc.RFID_UHF.GetReaderInfo(0))
                {
                    lbReaderInfo.Text = fc.RFID_UHF.InfoReader[2].ToString();
                    InfoAdd(fc.RFID_UHF.InfoReader[0].ToString());
                    InfoAdd(fc.RFID_UHF.InfoReader[1].ToString());
                    InfoAdd(fc.RFID_UHF.InfoReader[2].ToString());
                    InfoAdd(fc.RFID_UHF.InfoReader[3].ToString());
                }
            }
            finally
            {
                btReadTransponder.Enabled = true;
                btReadWriteData.Enabled = true;
                btGetVersion.Enabled = true;
            }
        }

        private void btReadWriteData_Click(object sender, EventArgs e)
        {
            try
            {
                btReadTransponder.Enabled = false;
                btReadWriteData.Enabled = false;
                btGetVersion.Enabled = false;
                if (cbReadWriteBox.SelectedIndex == 0)
                {
                    InfoAdd("Search...UID");
                    if (fc.RFID_UHF.GetUID_Repeat())
                    {
                        InfoAdd("TAG-Nr. :" + fc.RFID_UHF.UIDNr);
                        InfoAdd(fc.RFID_UHF.TagTyp);
                        fc.PlaySound();

                        if (fc.RFID_UHF.UIDNr.Length == 24)
                        {
                            if (fc.RFID_UHF.ReadTagBlock24_UHF(Convert.ToByte(NumBlock.Value), 4, 0))
                            {
                                InfoAdd(fc.RFID_UHF.BlockDataAScII);
                                txtData.Text = fc.RFID_UHF.BlockDataAScII;
                                InfoAdd("Read = OK");
                            }
                            else
                            {
                                InfoAdd("No Data found");
                                InfoAdd(fc.errortext);
                            }
                        }
                      
                        if (fc.RFID_UHF.UIDNr.Length == 16)
                        {
                            if (fc.RFID_UHF.ReadTagBlock(Convert.ToByte(NumBlock.Value), 2, 0))
                            {
                                InfoAdd(fc.RFID_UHF.BlockDataAScII);
                                txtData.Text = fc.RFID_UHF.BlockDataAScII;
                                InfoAdd("Read = OK");
                            }
                            else
                            {
                                InfoAdd("No Data found");
                            }
                        }
                    }
                    else
                    {
                        InfoAdd("No UID found");
                    }
                }
                if (cbReadWriteBox.SelectedIndex == 1)
                {
                    for (int i = txtData.Text.Length; i <= 8 - 1; i++)
                    {
                        txtData.Text = txtData.Text + " ";
                    }
                    InfoAdd("Search...UID");
                    if (fc.RFID_UHF.GetUID_Repeat())
                    {
                        InfoAdd("TAG-Nr. :" + fc.RFID_UHF.UIDNr);
                        InfoAdd(fc.RFID_UHF.TagTyp);
                        fc.PlaySound();
                        //InfoAdd(fc.RFID_UHF.TagTyp)
                        if (fc.RFID_UHF.UIDNr.Length == 24)
                        {
                            if (fc.RFID_UHF.WriteTagBlock24_UHF(Convert.ToByte(NumBlock.Value), 4, fc.RFID_UHF.ASCIIToHex(txtData.Text), 0)) // 8 digits ASCII = 16 digits hex
                            {
                                InfoAdd("Write = OK");
                            }
                            else
                            {
                                InfoAdd("Write = ERROR");
                            }
                        }

                        if (fc.RFID_UHF.UIDNr.Length == 16)
                        {
                            if (fc.RFID_UHF.WriteTagBlock(Convert.ToByte(NumBlock.Value), 2, txtData.Text, 0))
                            {
                                InfoAdd("Write = OK");
                            }
                            else
                            {
                                InfoAdd("Write = ERROR");
                            }
                        }
                    }
                    else
                    {
                        InfoAdd("No UID found");
                    }
                }
            }
            finally
            {
                btReadTransponder.Enabled = true;
                btReadWriteData.Enabled = true;
                btGetVersion.Enabled = true;
            }
        }

        private void frmHF_Load(object sender, System.EventArgs e)
        {
            cbReadWriteBox.SelectedIndex = 0;
        }

        private void cbReadWriteBox_SelectedIndexChanged(object sender, EventArgs e)
        {
            btReadWriteData.Text = cbReadWriteBox.Text;
        }

        private void ClearItem_Click(System.Object sender, System.EventArgs e)
        {
            ListBox1.Items.Clear();
        }

        private void ExitItem_Click(object sender, EventArgs e)
        {
            if (cbConti.Checked)
            {
                cbConti.Checked = false;
                InfoAdd("Stop Continues Read");
            }
            if (MessageBox.Show("Close Form ?", this.Text, MessageBoxButtons.YesNo, MessageBoxIcon.Question, MessageBoxDefaultButton.Button1) == DialogResult.Yes)
            {
                Close();
            }
        }

        private void menuItem4_Click(object sender, EventArgs e)
        {
            if (cbConti.Checked) {
                cbConti.Checked = false; 
            }
            this.Hide(); 
            fc.Hide();
            fc.Tray1.InitialDuration = 0;
            fc.Tray1.Visible = true;
        }

        private void txtData_KeyPress(object sender, KeyPressEventArgs e)
        {
         //   e.KeyChar = fc.CheckHexDigits(e.KeyChar);  
        }

        private void ItemUHF_Click(object sender, EventArgs e)
        {
            ListBox1.Items.Clear();
            InfoAdd("Close Reader");
            fc.CloseReader(0);
            MessageBox.Show("Please change the UHF-Reader." + '\r' + "Then they press OK.", this.Text, MessageBoxButtons.OK, MessageBoxIcon.Question, MessageBoxDefaultButton.Button2);
            fc.PlaySound();
            fc.Reader_Typ = 3;
            InfoAdd("Check UHF-Reader");
            fc.CheckReaderOnBoard();
            if (fc.RFID_UHF.IsActive)
            {
                InfoAdd("UHF-Reader found");
                InfoAdd("Check Version");
            }
            else
            {
                InfoAdd("ERROR: No UHF-Reader found");
            }
            btGetVersion_Click(null, null);
        }

    }
}